require"lib/TEsound"

module('assets', package.seeall)

imageDefs = {
	cloud1 = "cloud1.png",
	cloud2 = "cloud2.png",
	eshot = "eshot.png",
	explode1 = "explode1.png",
	bomb1 = "bomb1.png",
	green = { 
		fname = "green_ball.png",-- pad = 3
		r = 32 , ox = 36, oy = 36
	},
	big_love = { 
		fname = "big_love_ball.png",
		shape = "circle",
		r = 46 , ox = 48, oy = 48 
	},
	love = { 
		fname = "love_ball.png",
		r = 28 , ox = 32, oy = 32 
	},
	greybox = { 
		fname = "blocks1.png",
		w = 32, h = 32,
		ox = 16, oy = 16,
		quad = love.graphics.newQuad( 2+(0*34), 2+(6*34), 32, 32, 640, 400 )
	},
	brownbox = { 
		fname = "blocks2.png",
		w = 32, h = 32,
		ox = 16, oy = 16, 
		quad = love.graphics.newQuad( 2+(13*34), 2+(9*34), 32, 32, 640, 400 )
	},
	saucer = "saucer.png",	
	turretbase = "turretbase.png",	
}



sounds = {
	exp1 = love.sound.newSoundData("sounds/exp1.wav"),
	shoot1 = love.sound.newSoundData("sounds/shoot1.wav"),
	hit1 = love.sound.newSoundData("sounds/hit1.wav"),
	powerup1 = love.sound.newSoundData("sounds/powerup1.wav"),
	-- love.audio.newSource("techno.ogg")
}


-- w,h    	set from image
-- ox,oy 	offset [by center or 0,0]
-- center 	[true]
-- pad		padding [0]
-- r 		radius (width-pad*2 / 2)
function loadAndPrepImages()
	for k,v in pairs(imageDefs) do
		if (type(v)=='string') then 
			local s=v; 
			v = { fname = s } 
			imageDefs[k] = v
		end 
		print(v.fname)
		v.image = love.graphics.newImage('images/'..v.fname)

		v.w = v.w or v.image:getWidth()
		v.h = v.h or v.image:getHeight()
		v.pad = v.pad or 0
		v.r = v.r or (v.w-(v.pad*2)) / 2

		if v.center == false then
			v.ox = v.ox or 0
			v.oy = v.oy or 0
		else
			v.ox = v.ox or (v.w-(v.pad*2)) / 2
			v.oy = v.oy or (v.h-(v.pad*2)) / 2
		end
	end
end