
local drawMethods = draw.drawMethods
local collisionmap = collisions.collisionmap
local collisionfns = collisions.collisionfns

module('physics', package.seeall)


function beginContact(a, b, coll)
    -- colliding
	--local x,y = coll:getNormal()
    local au = a:getUserData()
    local bu = b:getUserData()
    local an = au.blk.name
    local bn = bu.blk.name
    --print(au.rig.name..' hit '..bu.rig.name)

    local hit
    for k,c in pairs(collisionmap) do
    	--print('c.a '..c.a..'c.b '..c.b..'an '..an..'bn '..bn)
    	hit = c.a==an and (c.b=='*' or c.b==bn)
    	if not hit then
    		hit = c.a==bn and (c.b=='*' or c.b==an)
    	end
    	hit = hit and ((not c.notself) or (an ~= bn))
    	if hit then
    		if not c.fu then
    			collisionfns[k](au,bu,coll,a,b)
    		elseif type(c.fu)=='function' then
    			c.fu(au,bu,coll,a,b)
    		else  
    			collisionfns[c.fu](au,bu,coll,a,b)
    		end
    	end
    end
end

function endContact(a, b, coll)
    -- uncolliding
end

function preSolve(a, b, coll)
    -- touching
end

function postSolve(a, b, coll)
    
end

-- Body:setContactFilter( filter )

---------------------------------------------------------------------------

-- ball.b:setMass(10)
-- ball.f:setRestitution(0.4)    -- make it bouncy
-- ball.f:setUserData("Ball")

physet = {}

physet.staticRect = function(rig, blk)
	blk.b = rig.mainbody
	blk.s = love.physics.newRectangleShape(blk.x, blk.y, blk.imgDef.w, blk.imgDef.h)
	blk.f = love.physics.newFixture(blk.b, blk.s)
	blk.draw = drawMethods.staticRect

	blk.f:setUserData({rig=rig, blk=blk})

	return blk
end

function physetf(rig, blk, bodyType) 
 	blk.b = blk.b or love.physics.newBody(rig.lvl.world, blk.x, blk.y, bodyType or "dynamic")
	blk.s = blk.s or love.physics.newRectangleShape(0, 0, blk.imgDef.w, blk.imgDef.h)
	blk.f = blk.f or love.physics.newFixture(blk.b, blk.s)
	blk.draw = blk.draw or drawMethods.dynamicRect

	blk.f:setUserData({rig=rig, blk=blk})

	return blk
end

physet.dynamicRect = physetf

physet.kinematicRect = function(rig, blk)
	return physetf(rig, blk, "kinematic")
end

physet.dynamicCircle = function(rig, blk)
	blk.r = blk.imgDef.r
	--blk.b = love.physics.newBody(rig.lvl.world, blk.x, blk.y, "dynamic")
	blk.s = love.physics.newCircleShape(blk.imgDef.r)
	--blk.f = love.physics.newFixture(blk.b, blk.s)
	blk.draw = drawMethods.dynamicCircle	
	return physetf(rig, blk)
end

physet.dynamicCircleNoSelfCollide = function(rig, blk)
	physet.dynamicCircle(rig, blk) 
	blk.f:setFilterData( 0xffff, 0xffff, -1) -- categoryBits, maskBits, groupIndex
	return blk
end